=== debian/changelog ===
ros-foxy-map-transformer (1.0.3-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Geoff <geoff@openrobotics.org>  Wed, 27 Jan 2021 03:23:27 -0000
